#include <bits/stdc++.h>

using namespace std;

const int maxn=1e5+10;
const int logg=30;

int a[maxn];
int klk[logg];

int main(){
    int n; cin>>n;
    for(int i=0;i<n;i++) cin>>a[i];
    for(int j=0;j<logg;j++){
        for(int i=0;i<n;i++){
            if(a[i]&(1<<j)) klk[j]++;
        }
    }
    int q; cin>>q;
    while(q--){
        int t; cin>>t;
        if(t==0){
            int k; cin>>k;
            int res=0;
            for(int j=0;j<logg;j++){
                if(klk[j]>=k){
                    res+=(1<<j);
                }
            }
            cout<<res<<"\n";
        }else{
            int k,x; cin>>k>>x;
            k--;
            for(int i=0;i<logg;i++){
                if(a[k]&(1<<i)) klk[i]--;
            }
            a[k]=x;
            for(int i=0;i<logg;i++){
                if(a[k]&(1<<i)) klk[i]++;
            }
        }
    }
    return 0;
}